#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <math.h>
#include <shellapi.h>
#include <dos.h>
#include <fcntl.h>
#include <mem.h>
#include <new.h>
#include <setjmp.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include "defines.h"
/*-----*/
char*progname=PROGNAME;
typedef uns char byte;
HMENU mainmenu; HWND mwn=0; HINSTANCE Instance=0,PrevInstance=0;
short CmdShow=0; byte Nn=0,fileopen=0;
char tit[256],title[256],file[256]={0},File[256]={0},Filo[256]={0},Film[256]={0};
OPENFILENAME ofn;
/*-----*/
class xyz{public: double x,y,z; /* in Win32 needn't be a power of 2 bytes long */
xyz(){x=y=z=0;};
xyz(double X,double Y,double Z){x=X; y=Y; z=Z;}
xyz operator+(xyz a){return xyz(x+a.x,y+a.y,z+a.z);}
xyz operator-(xyz a){return xyz(x-a.x,y-a.y,z-a.z);}
xyz operator-(){return xyz(-x,-y,-z);}
xyz operator*(double m){return xyz(x*m,y*m,z*m);}
xyz operator/(double m){return xyz(x/m,y/m,z/m);}
void operator+=(xyz a){x+=a.x; y+=a.y; z+=a.z;}
void operator-=(xyz a){x-=a.x; y-=a.y; z-=a.z;}
void operator*=(double m){x*=m; y*=m; z*=m;}
void operator/=(double m){x/=m; y/=m; z/=m;}
double operator*(xyz a){return x*a.x+y*a.y+z*a.z;}
double rr(){return x*x+y*y+z*z;}
double r(){return sqrt(x*x+y*y+z*z);}};
/*-----*/
int GetFileName(HWND wn,char*file,char*t,char*f,int write) {int j;
ofn.lStructSize=sizeof(OPENFILENAME); ofn.hwndOwner=wn;
ofn.lpstrFilter=f; ofn.lpstrCustomFilter=0; ofn.nFilterIndex=0;
ofn.lpstrFile=file; ofn.nMaxFile=128;
ofn.lpstrFileTitle=tit; ofn.nMaxFileTitle=256;
ofn.lpstrInitialDir=0; ofn.lpstrTitle=t;
ofn.Flags=write?OFN_OVERWRITEPROMPT:OFN_FILEMUSTEXIST;
j=(write?GetSaveFileName(&ofn):GetOpenFileName(&ofn))?1:0; return j;}
/*-----*/
int yesno(char*q){return MessageBox(0,q,"",MB_YESNO)==IDYES;}
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
char Z[5],*Y;
void endianrev(char*A,char*B,int n){int i; for(i=0;i<n;i++) A[n-1-i]=B[i];}
int   Sbg(char*C){endianrev(Z,C,2); return *(short*)Z;} /* bg = big-endian */
long  Lbg(char*C){endianrev(Z,C,4); return *(long *)Z;}
float Fbg(char*C){endianrev(Z,C,4); return *(float*)Z;}
xyz  Fbg3(char*C){xyz a; a.x=Fbg(C); a.y=Fbg(C+4); a.z=Fbg(C+8); return a;}
/*-----*/
class mtl{public: char*name,*colm,*bumm; xyz color,colc,cols,bumc,bums;
	 short cold,bumd,tex;};
/*-----*/
class uvinfo{public: xyz c,t; int n;};
/*-----*/
int readOBJ(char*file,char*File){FILE*H,*J;
FILE*F=fopen(file,"rb"); if(!F) {MessageBox(0,file,"I can't find this file",OUCH); return 1;}
FILE*G=fopen(File,"w");  if(!G) {fclose(F); MessageBox(0,file,"I can't open this file",OUCH); return 1;}
fprintf(G,"translation of texturing information in %s\n",file);
char L[256],Tt[5],*sn[1024],*sf=0,*pts=0,*q,*pols=0,*epols; mtl grs[1024];
int g,i,j,k,l,c,N,m,n,ns,c2,k2,npts=0,ngrs=0,nUV=0,splines=0,nurbs=0; uvinfo*uv=0;
fread(L,1,12,F); N=Lbg(L+4); fprintf(G,"this file has %d bytes\n",N+8);
Y=new char[N+1]; fread(Y,1,N,F); Y[N]=0; c=0;
double rx=MessageBox(0,"shall I mirror-image the model in x?","",MB_YESNO)==IDYES?-1:1;
LOOP: memcpy(Tt,Y+c,4); Tt[4]=0; k=Lbg(Y+c+4); m=c; c+=k+8; if(c&1) c++;
if(c>=N) goto WHOA; m+=8;
if(!strcmp(Tt,"PNTS")) {fprintf(G,"%6d vertexes\n",npts=k/12); pts=Y+m;
	 if(uv) delete uv; uv=new uvinfo[npts];}
else if(!strcmp(Tt,"POLS")) {j=0; pols=Y+m; epols=Y+c; while(m<c) {n=Sbg(Y+m); m+=2*n+4; j++;}
	 fprintf(G,"%6d polygons\n",j);}
else if(!strcmp(Tt,"CRVS")) {fprintf(G,"splines\n"); splines=1;}
else if(!strcmp(Tt,"PCHS")) {fprintf(G,"nurbs\n"); nurbs=1;}
else if(!strcmp(Tt,"SRFS")) {fprintf(G,"surfaces:-\n");
	 memcpy(sf=new char[k],Y+m,k); ns=0;
	 while(m<c) {fprintf(G,"%s\n",Y+m); m+=strlen(sn[ns++]=Y+m)+2; m&=0xfffffffe;}}
else if(!strcmp(Tt,"SURF")) {char*fm="",tex[5],pim=0;
	 if(ngrs<1024) ngrs++; mtl&M=grs[ngrs-1]; M.name=Y+m; M.color=xyz(.5,.5,.5); M.tex=0;
	 M.colm=M.bumm=0; M.colc=M.bumc=xyz(0,0,0); M.cols=M.bums=xyz(1,1,1); M.cold=M.bumd=0;
	 fprintf(G,"-----------------------------------------------------------\n");
	 i=strlen(Y+m); for(j=0;j<i;j++) if(Y[m+j]==' ') Y[m+j]='_'; tex[0]=0;
	 fprintf(G,"surface `%s':-\n",Y+m); m+=strlen(Y+m)+2; m&=0xfffffffe; c2=m;
	 LOOPSURF: memcpy(Tt,Y+c2,4); Tt[4]=0; c2+=4; k2=Sbg(Y+c2); c2+=2;
	 m=c2; c2=m+k2; if(c2&1) c2++; if(m>=c) goto WHOASURF;
	 if(!strcmp(Tt,"COLR")) {int i=Y[m]&255,j=Y[m+1]&255,k=Y[m+2]&255;
		  fprintf(G,"%3d red, %3d green, %3d blue\n",i,j,k);
		  grs[ngrs-1].color=xyz(i/255.,j/255.,k/255.);}
	 else if(!strcmp(Tt,"FLAG")) {j=Sbg(Y+m); fprintf(G,fm="flags:");
		  if(j&0x001) fprintf(G," luminous");
		  if(j&0x002) fprintf(G," outline");
		  if(j&0x004) fprintf(G," smoothing");
		  if(j&0x008) fprintf(G," colorhighlights");
		  if(j&0x010) fprintf(G," colorfilter");
		  if(j&0x020) fprintf(G," opaqueedge");
		  if(j&0x040) fprintf(G," transparentedge");
		  if(j&0x080) fprintf(G," sharpterminator");
		  if(j&0x100) fprintf(G," doublesided");
		  if(j&0x200) fprintf(G," additive");
		  if(j&0x400) fprintf(G," shadowalpha");
		  if(!(j&0x7ee)) fprintf(G," no flags set");
		  fprintf(G,"\n");}
	 else if(!strcmp(Tt,"LUMI")) fprintf(G,fm="luminosity   = %g%%\n",Sbg(Y+m)*100./256);
	 else if(!strcmp(Tt,"DIFF")) fprintf(G,fm="diffuseness  = %g%%\n",Sbg(Y+m)*100./256);
	 else if(!strcmp(Tt,"SPEC")) fprintf(G,fm="specularity  = %g%%\n",Sbg(Y+m)*100./256);
	 else if(!strcmp(Tt,"REFL")) fprintf(G,fm="reflectivity = %g%%\n",Sbg(Y+m)*100./256);
	 else if(!strcmp(Tt,"TRAN")) fprintf(G,fm="transparency = %g%%\n",Sbg(Y+m)*100./256);
	 else if(!strcmp(Tt,"VLUM")) fprintf(G,fm="luminosity   = %g\n",Fbg(Y+m));
	 else if(!strcmp(Tt,"VDIF")) fprintf(G,fm="diffuseness  = %g\n",Fbg(Y+m));
	 else if(!strcmp(Tt,"VSPC")) fprintf(G,fm="specularity  = %g\n",Fbg(Y+m));
	 else if(!strcmp(Tt,"VRFL")) fprintf(G,fm="reflectivity = %g\n",Fbg(Y+m));
	 else if(!strcmp(Tt,"VTRN")) fprintf(G,fm="transparency = %g\n",Fbg(Y+m));
	 else if(!strcmp(Tt,"GLOS")) {char S[64]; j=Sbg(Y+m); sprintf(S,"=%d",j);
		  fprintf(G,fm="glossiness %s\n",j==16?"low":j==64?"medium":j==256?"high":j==1024?"maximum":S);}
	 else if(!strcmp(Tt,"RFLT")) {j=Sbg(Y+m);
		  if(!(j&1)) fprintf(G,fm="don't reflect objects in scene\n");
		  if(!(j&2)) fprintf(G,fm="don't reflect the `image wrapped round scene'\n");}
	 else if(!strcmp(Tt,"GLOS")) {fprintf(G,fm="glossiness = %d\n",Sbg(Y+m));}
	 else if(!strcmp(Tt,"RIMG")) {fprintf(G,fm="wrap image round scene: %s\n",Y+m);}
	 else if(!strcmp(Tt,"RSAN")) {fprintf(G,fm="reflection map seam heading angl e= %g deg\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"RIND")) {fprintf(G,fm="index of refraction = %g\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"EDGE")) {fprintf(G,fm="edge transparency threshold = %g\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"SMAN")) {fprintf(G,fm="max smoothing angle = %g deg\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"CTEX")) {fprintf(G,fm="--- color texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"DTEX")) {fprintf(G,fm="--- diffuseness texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"STEX")) {fprintf(G,fm="--- specularity texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"RTEX")) {fprintf(G,fm="--- reflectiveness texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"TTEX")) {fprintf(G,fm="--- transparency texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"LTEX")) {fprintf(G,fm="--- luminosity texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"BTEX")) {fprintf(G,fm="--- bump texture, type `%s':-\n",Y+m);}
	 else if(!strcmp(Tt,"TFLG")) {fprintf(G,fm="texture option:"); j=Sbg(Y+m);
		  if(j&0x01) fprintf(G," X-axis");
		  if(j&0x02) fprintf(G," Y-axis");
		  if(j&0x04) fprintf(G," Z-axis");
		  if(j&0x08) fprintf(G," world_coords");
		  if(j&0x10) fprintf(G," negative_image");
		  if(j&0x20) fprintf(G," pixel_blending");
		  if(j&0x40) fprintf(G," antialiasing"); fprintf(G,"\n");
		  if(pim) if(!strcmp(tex,"CTEX")) M.cold=j;
			  else if(!strcmp(tex,"BTEX")) M.bumd=j;}
	 else if(!strcmp(Tt,"TSIZ")) {fprintf(G,fm="texture size = {%g,%g,%g}\n",Fbg(Y+m),Fbg(Y+m+4),Fbg(Y+m+8));
		  if(pim) if(!strcmp(tex,"CTEX")) M.cols=Fbg3(Y+m);
			  else if(!strcmp(tex,"BTEX")) M.bums=Fbg3(Y+m);}
	 else if(!strcmp(Tt,"TCTR")) {fprintf(G,fm="texture center = {%g,%g,%g}\n",Fbg(Y+m),Fbg(Y+m+4),Fbg(Y+m+8));
		  if(pim) if(!strcmp(tex,"CTEX")) M.colc=Fbg3(Y+m);
			  else if(!strcmp(tex,"BTEX")) M.bumc=Fbg3(Y+m);}
	 else if(!strcmp(Tt,"TFAL")) {fprintf(G,fm="texture falloff = {%g,%g,%g}\n",Fbg(Y+m),Fbg(Y+m+4),Fbg(Y+m+8));}
	 else if(!strcmp(Tt,"TVEL")) {fprintf(G,fm="texture velocity = {%g,%g,%g}\n",Fbg(Y+m),Fbg(Y+m+4),Fbg(Y+m+8));}
	 else if(!strcmp(Tt,"TCLR")) {fprintf(G,fm="modifying color = red %d, green %d, blue %d\n",Y[m]&255,Y[m+1]&255,Y[m+2]&255);}
	 else if(!strcmp(Tt,"TVAL")) {fprintf(G,fm="modifying value = %g\n",Sbg(Y+m)*100./256);}
	 else if(!strcmp(Tt,"TAMP")) {fprintf(G,fm="bump amplitude = %g\n",Fbg(Y+m));}
	 else if(!strncmp(Tt,"TFP",3)) {fprintf(G,fm="floatingpoint argument #%c = %g\n",Tt[3],Fbg(Y+m));}
	 else if(!strncmp(Tt,"TIP",3)) {fprintf(G,fm="integer argument #%c = %d\n",Tt[3],Sbg(Y+m));}
	 else if(!strncmp(Tt,"TSP",3)) {fprintf(G,fm="integer argument #%c = %d\n",Tt[3],Sbg(Y+m));}
	 else if(!strcmp(Tt,"TFRQ")) {fprintf(G,fm="noise frequency = %d\n",Sbg(Y+m));}
	 else if(!strcmp(Tt,"TIMG")) {fprintf(G,fm="texture with image %s\n",Y+m);
		  if(pim) if(!strcmp(tex,"CTEX")) M.colm=Y+m;
			  else if(!strcmp(tex,"BTEX")) M.bumm=Y+m;}
	 else if(!strcmp(Tt,"TALP")) {fprintf(G,fm="texture alpha with image %s\n",Y+m);}
	 else if(!strcmp(Tt,"TWRP")) {switch(Sbg(Y+m)) {default: fprintf(G,fm="TWRP with bad arg\n");
		  case 0: fprintf(G,fm="area outside image is black\n"); break;
		  case 1: fprintf(G,fm="area outside image is as closest image edge\n"); break;
		  case 2: fprintf(G,fm="the image is tiled\n"); break;
		  case 3: fprintf(G,fm="the image is tiled with reflection\n"); break;}}
	 else if(!strcmp(Tt,"TAAS")) {fprintf(G,fm="image antialiasing strength = %g\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"TOPC")) {fprintf(G,fm="texture opacity = %g\n",Fbg(Y+m));}
	 else if(!strcmp(Tt,"SHDR")) {fprintf(G,fm="plug-in shader `%s'\n",Y+m);}
	 else if(!strcmp(Tt,"SDAT")) {fprintf(G,fm="shader data (%d bytes of it)\n",c2-m);}
	 else if(!strcmp(Tt,"IMSQ")) {fprintf(G,fm="(image sequence info for movie)\n");}
	 else if(!strcmp(Tt,"FLYR")) {fprintf(G,fm="(image sequence info for Flyer clip)\n");}
	 else if(!strcmp(Tt,"IMCC")) {fprintf(G,fm="(color cycling options for movie)\n");}
	 else if(!strcmp(Tt,"GLOW")) {fprintf(G,fm="glow = %g\n",Fbg(Y+m));}
	 else fprintf(G,fm="unknown SURF subchunk %s, %d bytes\n",Tt,c2-m);
	 if(!strncmp(fm,"--- ",4)) {strncpy(tex,Tt,5); tex[4]=0; pim=!strcmp(Y+m,"Planar Image Map");}
	 goto LOOPSURF;
	 WHOASURF:;}
else {fprintf(G,"\n"); fprintf(G,"unknown chunk %s, %d bytes\n",Tt,c-m);}
goto LOOP;
WHOA:
if(!pts)   {MessageBox(0,file,"this file contains no vertexes",OUCH); goto L2;}
if(splines) MessageBox(0,file,"this file contains splines, and I can't translate splines",OUCH);
if(nurbs)   MessageBox(0,file,"this file contains nurbs, and I can't translate nurbs",OUCH);
if(!pols) {MessageBox(0,file,"this file contains no polygons",OUCH); goto L2;}
H=fopen(Filo,"w"); if(!H) goto L2;
j=strlen(Film); for(k=i=0;i<j;i++) if(Film[i]=='\\') k=i+1;
fprintf(H,"mtllib %s\n",Film+k);
for(q=pts,i=0;i<npts;i++,q+=12) {double x=Fbg(q),y=Fbg(q+4),z=Fbg(q+8);
	 fprintf(H,"v %g %g %g\n",x*rx,y,z); uv[i].c=xyz(x,y,z);}
for(g=0;g<ngrs;g++) {mtl&M=grs[g];
	 if(!M.colm) if(M.bumm) {M.colc=M.bumc; M.cols=M.bums; M.cold=M.bumd;}
	 M.tex=(!(M.cold&7))?0:M.colm?1:!!M.bumm;}
for(g=0;g<ngrs;g++) {mtl&M=grs[g]; char*s=M.name;
	 fprintf(H,"g %s\nusemtl %s\n",s,s);
	 if(M.tex) {
		  for(i=0;i<npts;i++) uv[i].n=-1;
		  for(q=pols;q<epols;) {m=Sbg(q); n=m<0?-m:m; q+=2; k=Sbg(q+2*n);
				if(k==g+1) for(j=0;j<n;j++) {
					 l=int(Sbg(q+j*2))&0xffff; if(l>=0) if(l<npts) uv[l].n=0;}
				q+=n*2+2; if(m<0) q+=2;}
		  for(i=0;i<npts;i++) {uvinfo&U=uv[i]; if(U.n) continue; U.n=nUV++; U.t=U.c-M.colc;
				double x=U.t.x/M.cols.x+.5,y=U.t.y/M.cols.y+.5,z=U.t.z/M.cols.z+.5;
				if(M.cold&1) fprintf(H,"vt %g %g\n",z,y); else
				if(M.cold&2) fprintf(H,"vt %g %g\n",x,z); else
								 fprintf(H,"vt %g %g\n",x,y);}}
	 for(q=pols;q<epols;) {m=Sbg(q); n=m<0?-m:m; q+=2; k=Sbg(q+2*n);
		  if(k==g+1) {fprintf(H,"f");
				for(j=0;j<n;j++) {l=long(Sbg(q+j*2))&0xffff;
					 fprintf(H," %d",l+1); if(M.tex) fprintf(H,"/%d",uv[l].n+1);}}
		  q+=n*2+2; if(m<0) q+=2; if(k==g+1) fprintf(H,"\n");}}
fclose(H);
J=fopen(Film,"w"); if(!J) goto L2;
for(i=0;i<ngrs;i++) {mtl&M=grs[i];
	 fprintf(J,"newmtl %s\nNs 30\nKa 0 0 0\nKd %g %g %g\nKs 1 1 1\n",
		M.name,M.color.x,M.color.y,M.color.z);
	 if(M.colm) fprintf(J,"map_Kd %s\n",M.colm);
	 if(M.bumm) fprintf(J,"map_Bump %s\n",M.bumm);}
fclose(J);
//MessageBox(0,file,"this file contains no pointers to texture maps that I can translate",MB_OK);
L2: delete Y; delete sf; delete uv; fclose(F); fclose(G); return 1;}
/*-----*/
char*help="In an .LWO Lightwave file:-\n\
Translate the texturing information onto a .TXT file in readable form.\n\
Translate the mesh onto an .OBJ file (polygons only, I can't translate splines and nurbs).\n\
Do not copy a file onto itself, as that may destroy the file.";
/*-----*/
LRESULT far pascal MainWinProc(HWND wn,UINT iMessage,WPARAM S,LPARAM L){PAINTSTRUCT PS;
WPARAM T; RECT R; long l; HDC dc;
static char*filterLWO="LWO files\000*.LWO\000\000";
static char*filterTXT="TXT files\000*.TXT\000\000";
static char*filterOBJ="OBJ files\000*.OBJ\000\000";
switch(iMessage) {default: DEF: return DefWindowProc(wn,iMessage,S,L);
case WM_ENTERIDLE: return 0;
case WM_CREATE:
    SetMenu(wn,mainmenu=LoadMenu(Instance,progname)); ShowWindow(wn,SW_SHOW/*MAXIMIZED*/);
    goto DEF;
case WM_CLOSE: if(fileopen) {
    MessageBeep(-1); SetTitle(wn,"Whoa there, I got a file open!!"); return 0;} goto DEF;
case WM_QUIT: goto DEF;
case WM_DESTROY: PostQuitMessage(0); return 0;
case WM_GETMINMAXINFO: {MINMAXINFO*p=(MINMAXINFO*)L;
	 p->ptMaxPosition.x=p->ptMaxPosition.y=-4; return 0;}
case WM_PAINT: GetClientRect(wn,&R); BeginPaint(wn,&PS); dc=GetDC(wn); GetClientRect(wn,&R);
	 DrawText(dc,help,strlen(help),&R,0x10); ReleaseDC(wn,dc); EndPaint(wn,&PS); goto DEF;
case WM_COMMAND: T=S; goto MENU;}
MENU: switch((unsigned short)T) {
case _READFILE_: file[0]=File[0]=0;
	 if(!GetFileName(wn,file,"file to read mesh from?",filterLWO,0)) goto DEF;
	 strcpy(Filo,file); strcpy(Filo+strlen(Filo)-3,"obj");
	 if(!GetFileName(wn,Filo,"file to write mesh to as .OBJ",filterOBJ,1)) goto DEF;
	 strcpy(Film,Filo); strcpy(Film+strlen(Film)-3,"mtl");
	 MessageBox(0,Film,"I will write a materials description to this file:-",MB_OK);
	 strcpy(File,Filo); strcpy(File+strlen(File)-3,"txt");
	 if(!GetFileName(wn,File,"file to write decoded texture info to?",filterTXT,1)) goto DEF;
	 if(!strcmp(file,File)) goto DEF;
READING: l=strlen(file); if(stricmp(file+l-4,".lwo")) goto RDBAD;
	 GetTitle(wn,title,256);
	 SetTitle(wn,"'Ang on a while, keep yer 'ands off that mouse, I'm busy with yer image!");
	 l=readOBJ(file,File); SetTitle(wn,title);
	 if(!l) MessageBox(wn,file,"I tried to read this file but it didn't work",OUCH); goto DEF;
	 RDBAD: MessageBox(wn,file,"bad suffix",OUCH); goto DEF;
    RDOK: return 0;
case _EXIT_: SendMessage(wn,WM_CLOSE,0,0); return 0;}
return 0;}
/*-----*/
static void Register(char*name,WNDPROC proc) {WNDCLASS c;
c.style=CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS; c.lpfnWndProc=proc; c.cbClsExtra=0;
c.cbWndExtra=2; c.hInstance=Instance; c.hIcon=LoadIcon(Instance,progname);
c.hCursor=LoadCursor(0,IDC_ARROW); c.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
c.lpszMenuName=0; c.lpszClassName=name; if(!RegisterClass(&c)) exit(0);}
/*-----*/
HWND newwindow(char*clas,char*name,long c=0){
HWND w=CreateWindow(clas,name,WS_OVERLAPPEDWINDOW|c,
    CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,Instance,0);
    if(w) {ShowWindow(w,SW_SHOW); UpdateWindow(w);} return w;}
/*-----*/
// Turn off warning: Parameter 'CmdLine' is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma argsused
// Turn off warning: 'MainWnd' is assigned a value that is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma option -w-aus
/*-----*/
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int nCmdShow){
MSG msg; Instance=hInst; PrevInstance=hPrev; CmdShow=(short)nCmdShow;
if(!hPrev) Register(progname,MainWinProc);
mwn=newwindow(progname,progname,/*WS_HSCROLL|WS_VSCROLL|*/WS_MAXIMIZE); if(!mwn) exit(0);
while(GetMessage(&msg,0,0,0)) {TranslateMessage(&msg); DispatchMessage(&msg);}
return msg.wParam;}
